<?php
/* --------------------------------------------------------------
   ScssCompilerFactory.php 2019-04-03
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Class SCSSCompilerFactory
 */
class ScssCompilerFactory
{
    /**
     * @return \ScssCompilerInterface
     */
    public function createCompiler()
    {

        if (false && extension_loaded('sass')) {
            return new SassCompiler();
        } else {
            return new ScssCompiler();
        }
    }

    private function __construct()
    {
    }


    /**
     * @return \ScssCompilerFactory
     */
    public static function create()
    {
        return new self();
    }
}

/**
 * @param $className
 *
 * @throws \Exception
 */

spl_autoload_register(static function ($className) {
    $base = __DIR__;

    $file = $base . DIRECTORY_SEPARATOR . $className . '.php';

    if (file_exists($file)) {
        require $file;
    }
});