<?php

/* --------------------------------------------------------------
   ContentService.inc.php 2019-04-15
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2019 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   --------------------------------------------------------------
*/

/**
 * Class ContentWriteService
 */
class ContentWriteService
{
    /**
     * @var ContentRepositoryInterface
     */
    protected $repository;
    
    
    /**
     * ContentService constructor.
     *
     * @param ContentRepositoryInterface $repository
     */
    public function __construct(ContentRepositoryInterface $repository)
    {
        $this->repository = $repository;
    }
    
    
    /**
     * Stores an info page content.
     *
     * @param InfoPageContent $infoPage
     */
    public function storeInfoPageContent(InfoPageContent $infoPage)
    {
        $this->repository->storeInfoPageContent($infoPage);
    }
    
    
    /**
     * Stores an link page content.
     *
     * @param LinkPageContent $linkPage
     */
    public function storeLinkPageContent(LinkPageContent $linkPage)
    {
        $this->repository->storeLinkPageContent($linkPage);
    }
    
    
    /**
     * Stores an info element content.
     *
     * @param InfoElementContent $infoElement
     */
    public function storeInfoElementContent(InfoElementContent $infoElement)
    {
        $this->repository->storeInfoElementContent($infoElement);
    }
}